// --------------------------- НАСТРОЙКИ ---------------------------
#define KEEP_SETTINGS 1     // Хранить ВСЕ настройки в памяти
#define SETTINGS_LOG 0      // Вывод всех настроек из EEPROM в порт при запуске (для отладки)
#define REMOTE_LOG 0        // Настройка своего пульта - вывод всех "Пойманных" кнопок в порт
#define MONO_STEREO 0       // 0 - Моно+Стерео, 1 - Моно (микрофон или одноканальный линейный), 2 - Стерео (линейный)

#define SCHEM 1             // 1 - схема от Slenk, 0 - схема от technotrasher
#define STRIPE_INDICATE 1   // Индикация на ленте
#define LED_INDICATE 0      // Индикация на диодах
#define SETTINGS_VOLUME 0   // 0 - лучше для тихого прослушивания, 1 - лучше отрабатывает для громкого

// лента
#define STRIPE_SPLIT 0      // 0 - цельная лента, 1 - разделена на два отрезка 
#define NUM_LEDS 102        // Количество светодиодов (если 5 метров по 60, то 300)
#define CURRENT_LIMIT 0     // Лимит по току в МИЛЛИАМПЕРАХ, автоматически управляет яркостью (пожалей свой блок питания!) 0 - выключить лимит

// пины
#define SOUND_L_LINE      A1  // ЛИНЕЙНЫЙ пин вход аудио, левый канал
#define SOUND_R_LINE      A2  // ЛИНЕЙНЫЙ пин вход аудио, правый канал
#define SOUND_R_LINE_FREQ A3  // ЛИНЕЙНЫЙ пин вход аудио для режима с частотами (через кондер)
#define SOUND_R_MIC       A5  // МИИКРОФОННЫЙ пин вход аудио, правый канал
#define SOUND_R_MIC_FREQ  A6  // МИИКРОФОННЫЙ аналоговый пин вход аудио для режима с частотами (через кондер)

#define LED_PIN           12  // Пин DI светодиодной ленты
#define POT_GND           A0  // Пин земля для потенциометра
#define IR_PIN             2  // Пин ИК приёмника

#if (SCHEM)                   // Если схема от Slenk
#if (MONO_STEREO == 0)        // Если режим "Моно+Стерео"
  #define BTN_RELAY        4  // Пин тумблера переключения MIC/LINE  
#endif
#else                         // Если схема от technotrasher
#define BTN_OnOff          3  // Пин кнопки On/Off (PIN --- КНОПКА --- GND)
#define BTN_RELAY          4  // Пин кнопки переключения MIC/LINE
#define RELAYon            7  // Пин реле (отключение питания микрофона)
#define LED_line           8  // Пин светодиода "ЛИНЕНЫЙ ВХОД" (оранжевый)
#define LED_OFF           10  // Пин светодиода Off (красный) и пин светодиода режимов
#define LED_ON            11  // Пин светодиода ON (зеленый)
#include "GyverButton.h"      // Подключить библиотеку для работы кнопок
GButton btn_OnOff(BTN_OnOff); // Объявить кнопку On/Off
GButton btn_RELAY(BTN_RELAY); // Объявить кнопку переключения MIC/LINE
#endif

#if LED_INDICATE              // Если индикации на диодах активна
#define LED_line           8  // Пин светодиода "ЛИНЕНЫЙ ВХОД" (оранжевый)
#define LED_IR             9  // Пин светодиода IR (синий). сопротивление 100 Ом  - так как он только работает на вспышки. на 220 Ом - не будет его видно.
#define LED_OFF           10  // Пин светодиода Off (красный)и пин светодиода режимов
#define LED_ON            11  // Пин светодиода ON (зеленый)
#endif

// отрисовка
#define MAIN_LOOP 5               // Период основного цикла отрисовки (по умолчанию 5)

// сигнал
#define EXP 1.4                   // степень усиления сигнала (для более "резкой" работы) (по умолчанию 1.4)
#define POTENT 1                  // 1 - используем потенциометр, 0 - используется внутренний источник опорного напряжения 1.1 В
#define EMPTY_COLOR HUE_PURPLE    // цвет "не горящих" светодиодов. Будет чёрный, если яркость 0
byte EMPTY_BRIGHT = 40;           // яркость "не горящих" светодиодов (0 - 255)

// нижний порог шумов
uint16_t LOW_PASS_mic = 780;        // нижний порог шумов режим VU, ручная настройка
uint16_t SPEKTR_LOW_PASS_mic = 50;  // нижний порог шумов режим спектра, ручная настройка
uint16_t LOW_PASS_line = 10;        // нижний порог шумов режим VU, ручная настройка
uint16_t SPEKTR_LOW_PASS_line = 40; // нижний порог шумов режим спектра, ручная настройка
#define EEPROM_LOW_PASS 1           // порог шумов хранится в энергонезависимой памяти (по умолч. 1)
#define LOW_PASS_ADD 13             // "добавочная" величина к нижнему порогу, для надёжности (режим VU)
#define LOW_PASS_FREQ_ADD 3         // "добавочная" величина к нижнему порогу, для надёжности (режим частот)

byte BRIGHTNESS = 255;      // Общая яркость (0 - 255) - настраивается пультом

// шкала громкости
float SMOOTH = 0.3;         // коэффициент плавности анимации VU (по умолчанию 0.5)
#define MAX_COEF 1.8        // коэффициент громкости (максимальное равно срднему * этот коэф) (по умолчанию 1.8)
#define CMU_CENTER 1        // 0 - к центру, 1 - из центра

// настройки радуги
byte RAINBOW_STEP = 5;      // шаг изменения цвета радуги в режиме "Шкала громкости - Радуга"

// режим цветомузыки
float SMOOTH_FREQ = 1.0;                    // коэффициент плавности анимации частот (по умолчанию 0.8)
float MAX_COEF_FREQ_mic = 1.5;              // коэффициент порога для "вспышки" цветомузыки (по умолчанию 1.5)
float MAX_COEF_FREQ_line = 1.5;             // коэффициент порога для "вспышки" цветомузыки (по умолчанию 1.5)
float MAX_COEF_FREQ_1[3] = {0.8, 1.4, 1.7}; // отдельные коэффициенты для впышек по частотам (по умолчанию 1.5)

#define SMOOTH_STEP 20            // шаг уменьшения яркости в режиме цветомузыки (чем больше, тем быстрее гаснет)
#define LOW_COLOR HUE_RED         // цвет низких частот
#define MID_COLOR HUE_GREEN       // цвет средних
#define HIGH_COLOR HUE_YELLOW     // цвет высоких

// режим стробоскопа
byte STROBE_PERIOD = 14;          // период вспышек, миллисекунды
#define STROBE_DUTY 20            // скважность вспышек (1 - 99) - отношение времени вспышки ко времени темноты
byte STROBE_COLOR = 0;            // цвет стробоскопа
byte STROBE_SMOOTH = 200;         // скорость нарастания/угасания вспышки (0 - 255)

// режим подсветки
char WHITE_TEMP = 0;              // Температура белого
byte LIGHT_COLOR = 0;             // Начальный цвет подсветки
byte LIGHT_SAT = 255;             // Начальная насыщенность подсветки
byte COLOR_SPEED = 100;

// режим эффектов
byte HUE_Effect = 0;              // Добавочный цвет к эффектам (0 красный, 80 зелёный, 140 молния, 190 розовый) - настраивается пультом
byte effect_delay = 20;           // Задержка для эффектов - настраивается пультом
byte new_rainbow_step = 5;        // Шаг радуги (1 - 30) - настраивается пультом

#define FIRE_CENTER 0             // Режим "Огонь" ( 0 - к центру, 1 - из центра )

const byte SPLIT_NUM_LEDS = NUM_LEDS / 2;     // Колличество пикселов в половине ленты
#if (FIRE_CENTER || STRIPE_SPLIT)             // Если огонь из центра или лента разделена - убрать нахлест
    #define FIRE_DIFFUS 0
    #define FIRE_VAL1 60
    #define FIRE_VAL2 120
#else
    const byte FIRE_DIFFUS = SPLIT_NUM_LEDS / 3 * 2; // Колличество пикселов накладывающихся друг на друга в рижемах "Огонь к центру", "Лёд и Пламень"
    #define FIRE_VAL1 40
    #define FIRE_VAL2 90
#endif
const int NUM_LEDS_PLUS = NUM_LEDS + FIRE_DIFFUS;
const byte SPLIT_NUM_LEDS_PLUS = NUM_LEDS_PLUS / 2;

// режим бегущих частот
byte RUNNING_SPEED = 15;

// режим анализатора спектра
byte HUE_START = 0;
byte HUE_STEP = 5;
#define LIGHT_SMOOTH 2

#define REMOTE_STEP 16         // Шаг изменения настроек (цвет, насыщенноть, яркость и тд.) пультом (1-2-4-8-16)

/*
  Цвета для HSV
    HUE_RED = 0,
    HUE_ORANGE = 32,
    HUE_YELLOW = 64,
    HUE_GREEN = 96,
    HUE_AQUA = 128,
    HUE_BLUE = 160,
    HUE_PURPLE = 192,
    HUE_PINK = 224
*/
// --------------------------- НАСТРОЙКИ ---------------------------

// ----- КНОПКИ ПУЛЬТА WAVGAT -----
#define BUTT_UP     0xF39EEBAD
#define BUTT_DOWN   0xC089F6AD
#define BUTT_LEFT   0xE25410AD
#define BUTT_RIGHT  0x14CE54AD
#define BUTT_OK     0x297C76AD
#define BUTT_1      0x4E5BA3AD
#define BUTT_2      0xE51CA6AD
#define BUTT_3      0xE207E1AD
#define BUTT_4      0x517068AD
#define BUTT_5      0x1B92DDAD
#define BUTT_6      0xAC2A56AD
#define BUTT_7      0x5484B6AD
#define BUTT_8      0xD22353AD
#define BUTT_9      0xDF3F4BAD
#define BUTT_0      0xF08A26AD
#define BUTT_STAR   0x68E456AD
#define BUTT_HASH   0x151CD6AD
// ----- КНОПКИ ПУЛЬТА -----

// ------------------------------ ДЛЯ РАЗРАБОТЧИКОВ --------------------------------
const byte STRIPE = NUM_LEDS / 5;
//#define STRIPE NUM_LEDS / 5
const float freq_to_stripe = NUM_LEDS / 40; // /2 так как симметрия, и /20 так как 20 частот

#define FHT_N 64        // Ширина спектра х2
#define LOG_OUT 1
#include <FHT.h>        // Преобразование Хартли
#include <EEPROMex.h>   // Подключить библиотеку для работы с памятью
#include "FastLED.h"    // Подключить библиотеку для работы с лентой
CRGB leds[NUM_LEDS];    // Объявить ленту
#include "IRLremote.h"  // Подключить библиотеку для работы с ИК пультом
CHashIR IRLremote;      // Объявить ИК управление
uint32_t IRdata;        // Переменная для ИК команд

// градиент-палитра от зелёного к красному
DEFINE_GRADIENT_PALETTE(soundlevel_gp) {
  0,    0,    255,  0,  // green
  100,  255,  255,  0,  // yellow
  150,  255,  100,  0,  // orange
  200,  255,  50,   0,  // red
  255,  255,  0,    0   // red
};
CRGBPalette32 myPal = soundlevel_gp;

byte heat[NUM_LEDS_PLUS];     // Главный массив

#define N_PEAKS 25
bool pattern;

byte Rlenght, Llenght;
int RsoundLevel, RsoundLevel_f, LsoundLevel, LsoundLevel_f;
#if (SETTINGS_VOLUME)
int RsoundLevel_min, LsoundLevel_min;
#endif
float averageLevel = 50;
int maxLevel = 100;
byte hue;
unsigned long main_timer, effect_timer, effect_timer2, eeprom_timer;
const float averK = 0.006;
byte count;
const float index = (float)255 / SPLIT_NUM_LEDS;   // коэффициент перевода для палитры
int RcurrentLevel, LcurrentLevel;
int colorMusic[3];
float colorMusic_f[3], colorMusic_aver[3];
const byte color_arr[] = {LOW_COLOR, MID_COLOR, HIGH_COLOR};
boolean colorMusicFlash[3], running_flag[3], strobeUp_flag, strobeDwn_flag, eeprom_flag;
boolean settings_mode = false, cmu3_5_mode, strobe_mode = false;
#if (MONO_STEREO == 2)
boolean line_mode = false;    // true - микрофон, false - линейный
#else
boolean line_mode = true;     // true - микрофон, false - линейный
#endif
byte this_mode = 1;           // Режим по умолчанию
int strobe_bright = 0;
byte thisBright[3];
unsigned int light_time = STROBE_PERIOD * STROBE_DUTY / 10;
char freq_strobe_mode = 3, light_mode, cmu_mode, cmu_color_mode, effect_mode;
int freq_max;
float freq_max_f;
int freq_f[32];
byte this_color;
byte OK_count = 0;            //Счетчик нажатия клавиши ОК на пульте.

#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))
//========================================================================================

// --- Объявление всех использующихся функций для более быстрой и беспроблемной компиляции (на конечный размер скетча никак не влияет)
// --- Вкладка 02 --------------------------------------------------------------------------------------------------------------------
void fullLowPass();
void autoLowPass();
void analyzeAudio();
void sound_level();
void spektr_level();
void VOID_FREQ(float val);  // Функция ручной настройки чувствительности
void LOW_PASS(float val);   // Функция ручной настройки шума

// --- Вкладка 03 --------------------------------------------------------------------------------------------------------------------
bool timer_func (int val = effect_delay);                                           // Таймер
void indicate (byte val = 0);                                                       // Индикация на ленте
void buttonTickLed();                                                               // Нажатия кнопки
void butt_OK();                                                                     // Кнопка ОК
void(* resetFunc) (void) = 0;                                                       // Перезагрузка
void standby();                                                                     // Режим ожидания
void one_color_all(byte all_color, byte all_sat, byte all_bright);                  // Функция делает всю ленту выбранным цветом
int smartIncr(int value, int incr_step, int mininmum, int maximum);                 // Функция, изменяет величину value на шаг incr в пределах minimum.. maximum
float smartIncrFloat(float value, float incr_step, float mininmum, float maximum);  // Функция, изменяет величину value на шаг incr в пределах minimum.. maximum

void updateEEPROM();                                                          // Сохренение настроек в память
void readEEPROM();                                                            // Чтение настроек из памяти
void eepromTick();                                                            // Проверка не пора ли сохранить настройки
#if (SCHEM == 0)                                                              // Если схема от technotrasher
void buttonTick();                                                            // Обработка кнопок на передней панели
void Relay_OnOff();                                                           // Включить микрофон
#endif
// --- Вкладка 04 --------------------------------------------------------------------------------------------------------------------
void new_effect();                                                            // Режим эффектов
void new_rainbow_loop();                                                      // Плавная вращающаяся радуга
void addGlitter();                                                            // Искры   
void brights_dec();                                                           // Случайная вспышка и затухание
void random_color_pop(byte amount_points, byte flag_clear, byte min_bright);  // Случайная смена цветов
void confetti();                                                              // Конфетти
void sinelon();                                                               // Бегающая точка с исчезающими следами
void bpm();                                                                   // Пульсирующие цветные полосы
void juggle();                                                                // Восемь сплетающихся цветных точек    
void Fire(byte Cooling, byte Sparking, byte HUE_K = 0);                       // Огонь к центру
void setPixelHeatColor (int Pixel, byte heatramp, byte color_a = 0);          // Функция для огня к центру
CRGB getColor(byte val, byte val1, byte val2, byte MIN_SAT = 245, byte MAX_SAT = 255, byte MIN_BRIGHT = 70, byte MAX_BRIGHT = 255, byte HUE_START = 0, char HUE_GAP = 21);    // Функция возвращает цвет для одного пикселя
void Perlin(byte MIN_SAT = 245, byte MAX_SAT = 255, byte MIN_BRIGHT = 70, byte MAX_BRIGHT = 255, byte HUE_START = 0, char HUE_GAP = 21, byte STEP = 15, char plus_delay = 8); // Перлин
// --- Вкладка 05 --------------------------------------------------------------------------------------------------------------------
void animation();                                                             // Отрисовка
// --- Вкладка 06 --------------------------------------------------------------------------------------------------------------------
void remoteTick();                                                            // опрос ИК пульта
// --- Вкладка 07 --------------------------------------------------------------------------------------------------------------------
void doVisualization();                                                       // Огоньки наперегонки
